// ----------------------------------------------------------------------------
//
//  Copyright (C) 2020 Fons Adriaensen <fons@linuxaudio.org>
//    
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ----------------------------------------------------------------------------


#ifndef __SN3DPAN1_H
#define __SN3DPAN1_H


#include "ladspaplugin.h"


class Ladspa_Sn3dpan1 : public LadspaPlugin
{
public:

    enum { INP = 0, OUT = 1, CTL_EL = 5, CTL_AZ, NPORT, BSIZE = 64 }; 

    Ladspa_Sn3dpan1 (unsigned long fsam) : LadspaPlugin (fsam) {}
    virtual void setport (unsigned long port, LADSPA_Data *data);  
    virtual void active  (bool act);  
    virtual void runproc (unsigned long len, bool add);
    virtual ~Ladspa_Sn3dpan1 (void) {}  

    static LADSPA_Handle create (const struct _LADSPA_Descriptor *desc, unsigned long rate);
    static const LADSPA_PortDescriptor  portdescr [NPORT]; 
    static const char * const           portnames [NPORT]; 
    static const LADSPA_PortRangeHint   porthints [NPORT]; 

private:

    float  *_port [NPORT];
    float   _G1 [4];
};


class Ladspa_Sn3dpan1s : public LadspaPlugin
{
public:

    enum { INP = 0, OUT = 2, CTL_EL = 6, CTL_AZ, CTL_SW, NPORT, BSIZE = 64 }; 

    Ladspa_Sn3dpan1s (unsigned long fsam) : LadspaPlugin (fsam) {}
    virtual void setport (unsigned long port, LADSPA_Data *data);  
    virtual void active  (bool act);  
    virtual void runproc (unsigned long len, bool add);
    virtual ~Ladspa_Sn3dpan1s (void) {}  

    static LADSPA_Handle create (const struct _LADSPA_Descriptor *desc, unsigned long rate);
    static const LADSPA_PortDescriptor  portdescr [NPORT]; 
    static const char * const           portnames [NPORT]; 
    static const LADSPA_PortRangeHint   porthints [NPORT]; 

private:

    float  *_port [NPORT];
    float   _GL1 [4];
    float   _GR1 [4];
};


#endif
