// ----------------------------------------------------------------------------
//
//  Copyright (C) 2020 Fons Adriaensen <fons@linuxaudio.org>
//    
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ----------------------------------------------------------------------------


#ifndef __ZROTATOR1_H
#define __ZROTATOR1_H


#include "ladspaplugin.h"


class Ladspa_Zrotator1 : public LadspaPlugin
{
public:

    enum { INP = 0, OUT = 4, CTL_AZ = 8, NPORT }; 

    Ladspa_Zrotator1 (unsigned long fsam) : LadspaPlugin (fsam) {}
    virtual void setport (unsigned long port, LADSPA_Data *data);  
    virtual void active  (bool act);  
    virtual void runproc (unsigned long len, bool add);
    virtual ~Ladspa_Zrotator1 (void) {}  

    static LADSPA_Handle create (const struct _LADSPA_Descriptor *desc, unsigned long rate);
    static const LADSPA_PortDescriptor  portdescr [NPORT]; 
    static const char * const           portnames [NPORT]; 
    static const LADSPA_PortRangeHint   porthints [NPORT]; 

private:

    void calcpar (float az);

    float  *_port [NPORT];
    float   _c1, _s1;
};


#endif
